b32fc493f8536e277a7928503c2429b2828c72de
[xfstests-dev.git] / tests / xfs / 098
1 #! /bin/bash
2 # FS QA Test No. 098
3 #
4 # Create and populate an XFS filesystem, corrupt the journal, then see how
5 # the kernel and xfs_repair deal with it.
6 #
7 #-----------------------------------------------------------------------
8 # Copyright (c) 2015 Oracle, Inc.  All Rights Reserved.
9 #
10 # This program is free software; you can redistribute it and/or
11 # modify it under the terms of the GNU General Public License as
12 # published by the Free Software Foundation.
13 #
14 # This program is distributed in the hope that it would be useful,
15 # but WITHOUT ANY WARRANTY; without even the implied warranty of
16 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
17 # GNU General Public License for more details.
18 #
19 # You should have received a copy of the GNU General Public License
20 # along with this program; if not, write the Free Software Foundation,
21 # Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
22 #-----------------------------------------------------------------------
23 #
24
25 seq=`basename $0`
26 seqres=$RESULT_DIR/$seq
27 echo "QA output created by $seq"
28
29 here=`pwd`
30 tmp=/tmp/$$
31 status=1        # failure is the default!
32 trap "_cleanup; exit \$status" 0 1 2 3 15
33
34 _cleanup()
35 {
36     cd /
37     #rm -f $tmp.*
38 }
39
40 # get standard environment, filters and checks
41 . ./common/rc
42 . ./common/filter
43 . ./common/attr
44 . ./common/populate
45
46 # real QA test starts here
47 _supported_fs xfs
48 _supported_os Linux
49
50 # We corrupt XFS on purpose, and check if assert failures would crash system.
51 _require_no_xfs_bug_on_assert
52 _require_scratch
53 test -n "${FORCE_FUZZ}" || _require_scratch_xfs_crc
54 _require_attrs
55 _require_populate_commands
56 _require_xfs_db_blocktrash_z_command
57 test -z "${FUZZ_ARGS}" && FUZZ_ARGS="-n 8 -3"
58
59 rm -f $seqres.full
60
61 TESTDIR="${SCRATCH_MNT}/scratchdir"
62 TESTFILE="${TESTDIR}/testfile"
63
64 echo "+ create scratch fs"
65 _scratch_mkfs_xfs > /dev/null
66
67 echo "+ mount fs image"
68 _scratch_mount
69 blksz="$(stat -f -c '%s' "${SCRATCH_MNT}")"
70
71 echo "+ make some files"
72 mkdir -p "${TESTDIR}"
73 for x in `seq 1 1024`; do
74         touch "${SCRATCH_MNT}/junk.${x}"
75         inode="$(stat -c '%i' "${SCRATCH_MNT}/junk.${x}")"
76         if [ "$x" -gt 512 ] && [ "$((inode % 64))" -eq 0 ]; then
77                 mv "${SCRATCH_MNT}/junk.${x}" "${TESTFILE}.1"
78                 break
79         fi
80 done
81 for x in `seq 2 64`; do
82         touch "${TESTFILE}.${x}"
83 done
84 inode="$(stat -c '%i' "${TESTFILE}.1")"
85 umount "${SCRATCH_MNT}"
86
87 echo "+ check fs"
88 _scratch_xfs_repair -n >> $seqres.full 2>&1 || _fail "xfs_repair should not fail"
89
90 echo "+ corrupt image"
91 logstart="$(_scratch_xfs_get_sb_field logstart)"
92 logstart="$(_scratch_xfs_db -c "convert fsblock ${logstart} byte" | sed -e 's/^.*(\([0-9]*\).*$/\1/g')"
93 logblocks="$(_scratch_xfs_get_sb_field logblocks)"
94 $XFS_IO_PROG -f -c "pwrite -S 0x62 ${logstart} $((logblocks * blksz))" "${SCRATCH_DEV}" >> $seqres.full
95
96 echo "+ mount image"
97 _try_scratch_mount 2>/dev/null && _fail "mount should not succeed"
98
99 echo "+ repair fs"
100 _repair_scratch_fs >> $seqres.full 2>&1
101
102 # We may trigger assert related WARNINGs if we corrupt log on a
103 # CONFIG_XFS_WARN or CONFIG_XFS_DEBUG (CONFIG_XFS_ASSERT_FATAL is
104 # disabled) build, so filter them.
105 _check_dmesg _filter_assert_dmesg
106
107 echo "+ mount image (2)"
108 _scratch_mount
109
110 echo "+ chattr -R -i"
111 $CHATTR_PROG -R -f -i "${SCRATCH_MNT}/"
112
113 echo "+ modify files (2)"
114 broken=0
115 for x in `seq 1 64`; do
116         test -e "${TESTFILE}.${x}" || continue
117         echo moo | dd oflag=append conv=notrunc of="${TESTFILE}.${x}" 2>/dev/null
118         test $? -ne 0 && broken=1
119 done
120 echo "broken: ${broken}"
121 umount "${SCRATCH_MNT}"
122
123 echo "+ check fs (2)"
124 _scratch_xfs_repair -n >> $seqres.full 2>&1 || _fail "xfs_repair should not fail"
125
126 status=0
127 exit